﻿Module Module1
    Class SchoolMember
        Private f_name As String
        Private f_age As Integer

        'Define the constructor
        Public Sub New(n As String, a As Integer)
            Name = n
            Age = a
            Console.WriteLine("A school member was initialized")
        End Sub

        'Define the property Name
        Public Property Name As String
            Get
                Return f_name
            End Get
            Set
                If Value <> "" Then
                    f_name = Value
                Else
                    Throw New Exception("Name cannot be empty")
                End If
            End Set
        End Property

        'Define the property Age
        Public Property Age As Integer
            Get
                Return f_age
            End Get
            Set
                If Value > 0 Then
                    f_age = Value
                Else
                    Throw New Exception("Age cannot be negative or zero")
                End If
            End Set
        End Property
    End Class

    Class Teacher
        Inherits SchoolMember

        Private f_salary As Double 'This is an additional field for class Teacher

        'Define the constructor
        Public Sub New(n As String, a As Integer, s As Double)
            MyBase.New(n, a) 'Call the constructor of the class SchoolMember
            Salary = s
            Console.WriteLine("A teacher was initialized")
        End Sub

        'Define the property Salary
        Public Property Salary As Double
            Get
                Return f_salary
            End Get
            Set
                If Value >= 0 Then
                    f_salary = Value
                Else
                    Throw New Exception("Salary cannot be negative")
                End If
            End Set
        End Property
    End Class

    Class Student
        Inherits SchoolMember

        Private f_grades(2) As Integer 'This is an additional field for class Student

        'Define the constructor
        Public Sub New(n As String, a As Integer, g() As Integer)
            MyBase.New(n, a) 'Call the constructor of the class SchoolMember
            Grades = g
            Console.WriteLine("A student was initialized")
        End Sub

        'Define the property Grades
        Public Property Grades
            Get
                Return f_grades
            End Get
            Set
                Dim negative_found As Boolean
                negative_found = False
                For Each g In Value
                    If g < 0 Then
                        negative_found = True
                    End If
                Next

                If negative_found = False Then
                    f_grades = Value
                Else
                    Throw New Exception("Grades cannot be negative")
                End If
            End Set
        End Property
    End Class

    'Main code starts here
    Sub Main()
        Dim teacher1 = New Teacher("Mr. John Scott", 43, 35000)
        Dim teacher2 = New Teacher("Mrs. Ann Carter", 5, 32000)

        Dim student1 = New Student("Peter Nelson", 14, {90, 95, 92})
        Dim student2 = New Student("Helen Morgan", 13, {92, 97, 94})

        Console.WriteLine(teacher1.Name)
        Console.WriteLine(teacher1.Age)
        Console.WriteLine(teacher1.Salary)

        Console.WriteLine(student2.Name)
        Console.WriteLine(student2.Age)
        For Each grade In student2.Grades
            Console.WriteLine(grade)
        Next

        Console.ReadKey()
    End Sub
End Module
